/*
 SignaturePad: A jQuery plugin for assisting in the creation of an HTML5 canvas
 based signature pad. Records the drawn signature in JSON for later regeneration.

 Dependencies: FlashCanvas 1.5, json2, jquery-1.3.2+

 @project ca.thomasjbradley.applications.signaturepad
 @author Thomas J Bradley <hey@thomasjbradley.ca>
 @link http://thomasjbradley.ca/lab/signature-pad
 @link http://github.com/thomasjbradley/signature-pad
 @copyright Copyright MMXI, Thomas J Bradley
 @license New BSD License
 @version 2.0.4
*/
(function(b){function p(h,l){function n(d,c,e,i){var h=b(c).offset();clearTimeout(k);k=!1;typeof d.changedTouches!=="undefined"?(c=Math.floor(d.changedTouches[0].pageX-h.left+e.left),d=Math.floor(d.changedTouches[0].pageY-h.top+e.top)):(c=Math.floor(d.pageX-h.left),d=Math.floor(d.pageY-h.top));if(g.x===c&&g.y===d)return!0;if(g.x===null)g.x=c;if(g.y===null)g.y=d;i&&(d+=i);f.beginPath();f.moveTo(g.x,g.y);f.lineTo(c,d);f.lineCap=a.penCap;f.stroke();f.closePath();j.push({lx:c,ly:d,mx:g.x,my:g.y});g.x=
c;g.y=d}function m(){e.unbind("mousemove.signaturepad");typeof this.ontouchstart!=="undefined"&&e.each(function(){this.ontouchmove=null});g.x=null;g.y=null;j.length>0&&b(a.output,c).val(JSON.stringify(j))}function o(){m();f.fillStyle=a.bgColour;f.fillRect(0,0,i.width,i.height);if(!a.displayOnly)f.beginPath(),f.lineWidth=a.lineWidth,f.strokeStyle=a.lineColour,f.moveTo(a.lineMargin,a.lineTop),f.lineTo(i.width-a.lineMargin,a.lineTop),f.stroke(),f.closePath();f.lineWidth=a.penWidth;f.strokeStyle=a.penColour;
b(a.output,c).val("");j=[]}function r(a){var c;c=b(document).scrollTop();var f=0,e,g,h;c>0&&(e=a.offsetTop-b(a).offset().top,b(document).scrollTop(0),f=a.offsetTop-b(a).offset().top,b(document).scrollTop(c));c=b(document).scrollLeft();g=0;c>0&&(h=a.offsetLeft-b(a).offset().left,b(document).scrollLeft(0),g=a.offsetLeft-b(a).offset().left,b(document).scrollLeft(c));return{top:e!==f?b(document).scrollTop():0,left:h!==g?b(document).scrollLeft():0}}function s(a,b){e.bind("mousemove.signaturepad",function(a){n(a,
this)});typeof this.ontouchstart!=="undefined"?(e.each(function(){this.ontouchmove=function(a){n(a,this,r(this))}}),n(a,b,r(b),1)):n(a,b,null,1)}function q(){b(a.typed,c).hide();o();e.bind("mousedown.signaturepad",function(a){s(a,this)});e.bind("mouseup.signaturepad",function(){m()});e.bind("mouseleave.signaturepad",function(){k||(k=setTimeout(function(){m();clearTimeout(k);k=!1},200))});typeof this.ontouchstart!=="undefined"&&e.each(function(){this.ontouchstart=function(a){a.preventDefault();s(a,
this)};this.ontouchend=function(){m()};this.ontouchcancel=function(){m()}});b(a.clear,c).bind("click.signaturepad",function(){o();return!1});b(a.typeIt,c).bind("click.signaturepad",function(){t();return!1});b(a.drawIt,c).unbind("click.signaturepad");b(a.drawIt,c).bind("click.signaturepad",function(){return!1});b(a.typeIt,c).removeClass(a.currentClass);b(a.drawIt,c).addClass(a.currentClass);b(a.sig,c).addClass(a.currentClass);b(a.typeItDesc,c).hide();b(a.drawItDesc,c).show();b(a.clear,c).show()}function t(){o();
e.unbind("mousedown.signaturepad");e.unbind("mouseup.signaturepad");e.unbind("mousemove.signaturepad");e.unbind("mouseleave.signaturepad");b(a.clear,c).unbind("click.signaturepad");b(a.typed,c).show();b(a.drawIt,c).bind("click.signaturepad",function(){q();return!1});b(a.typeIt,c).unbind("click.signaturepad");b(a.typeIt,c).bind("click.signaturepad",function(){return!1});b(a.output,c).val("");b(a.drawIt,c).removeClass(a.currentClass);b(a.typeIt,c).addClass(a.currentClass);b(a.sig,c).removeClass(a.currentClass);
b(a.drawItDesc,c).hide();b(a.clear,c).hide();b(a.typeItDesc,c).show()}function u(d){for(b(a.typed,c).html(d.replace(/>/g,"&gt;").replace(/</g,"&lt;"));b(a.typed,c).width()>i.width;)d=b(a.typed,c).css("font-size").replace(/px/,""),b(a.typed,c).css("font-size",d-1+"px")}function v(){var d=!0;b("p."+a.errorClass,c).remove();c.removeClass(a.errorClass);b("input, label",c).removeClass(a.errorClass);a.drawOnly&&j.length<1&&(b(h).prepend('<p class="'+a.errorClass+'">'+a.errorMessageDraw+"</p>"),d=!1);b(a.name,
c).val()===""&&(b(h).prepend('<p class="'+a.errorClass+'">'+a.errorMessage+"</p>"),b(a.name,c).focus(),b(a.name,c).addClass(a.errorClass),b("label[for="+b(a.name).attr("id")+"]",c).addClass(a.errorClass),d=!1);return d}function p(){b(a.typed,c).bind("selectstart.signaturepad",function(a){return b(a.target).is(":input")});e.bind("selectstart.signaturepad",function(a){return b(a.target).is(":input")});!i.getContext&&FlashCanvas&&FlashCanvas.initElement(i);i.getContext&&(f=i.getContext("2d"),b(a.sig,
c).show(),a.displayOnly||(a.drawOnly||(b(a.name,c).bind("keyup.signaturepad",function(){u(b(this).val())}),b(a.name,c).bind("blur.signaturepad",function(){u(b(this).val())}),b(a.drawIt,c).bind("click.signaturepad",function(){q();return!1})),a.drawOnly||a.defaultAction==="drawIt"?q():t(),a.validateFields&&(b(h).is("form")?b(h).bind("submit.signaturepad",function(){return v()}):b(h).parents("form").bind("submit.signaturepad",function(){return v()})),b(a.sigNav,c).show()))}var w=this,a=b.extend({},b.fn.signaturePad.defaults,
l),c=b(h),e=b(a.canvas,c),i=e.get(0),f=null,g={x:null,y:null},j=[],k=!1;b.extend(w,{init:function(){p()},regenerate:function(d){w.clearCanvas();b(a.typed,c).hide();typeof d==="string"&&(d=JSON.parse(d));for(var e in d)if(typeof d[e]==="object")f.beginPath(),f.moveTo(d[e].mx,d[e].my),f.lineTo(d[e].lx,d[e].ly),f.lineCap=a.penCap,f.stroke(),f.closePath(),j.push({lx:d[e].lx,ly:d[e].ly,mx:d[e].mx,my:d[e].my});b(a.output,c).length>0&&b(a.output,c).val(JSON.stringify(j))},clearCanvas:function(){o()},getSignature:function(){return j},
getSignatureString:function(){return JSON.stringify(j)},getSignatureImage:function(){return i.toDataURL()}})}b.fn.signaturePad=function(b){var l=null;this.each(function(){l=new p(this,b);l.init()});return l};b.fn.signaturePad.defaults={defaultAction:"typeIt",displayOnly:!1,drawOnly:!1,canvas:"canvas",sig:".sig",sigNav:".sigNav",bgColour:"#ffffff",penColour:"#145394",penWidth:2,penCap:"round",lineColour:"#ccc",lineWidth:2,lineMargin:5,lineTop:35,name:".name",typed:".typed",clear:".clearButton",typeIt:".typeIt a",
drawIt:".drawIt a",typeItDesc:".typeItDesc",drawItDesc:".drawItDesc",output:".output",currentClass:"current",validateFields:!0,errorClass:"error",errorMessage:"Please enter your name",errorMessageDraw:"Please sign the document"}})(jQuery);
